// Code generated by mockery v2.15.0. DO NOT EDIT.

package mocks

import (
	mock "github.com/stretchr/testify/mock"
	content "gitlab.com/commonground/don/don-vito/pkg/content"

	plumbing "github.com/go-git/go-git/v5/plumbing"
)

// Storage is an autogenerated mock type for the Storage type
type Storage struct {
	mock.Mock
}

type Storage_Expecter struct {
	mock *mock.Mock
}

func (_m *Storage) EXPECT() *Storage_Expecter {
	return &Storage_Expecter{mock: &_m.Mock}
}

// ExtractRepositoryFiles provides a mock function with given fields:
func (_m *Storage) ExtractRepositoryFiles() ([]*content.RepositoryFile, error) {
	ret := _m.Called()

	var r0 []*content.RepositoryFile
	if rf, ok := ret.Get(0).(func() []*content.RepositoryFile); ok {
		r0 = rf()
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).([]*content.RepositoryFile)
		}
	}

	var r1 error
	if rf, ok := ret.Get(1).(func() error); ok {
		r1 = rf()
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// Storage_ExtractRepositoryFiles_Call is a *mock.Call that shadows Run/Return methods with type explicit version for method 'ExtractRepositoryFiles'
type Storage_ExtractRepositoryFiles_Call struct {
	*mock.Call
}

// ExtractRepositoryFiles is a helper method to define mock.On call
func (_e *Storage_Expecter) ExtractRepositoryFiles() *Storage_ExtractRepositoryFiles_Call {
	return &Storage_ExtractRepositoryFiles_Call{Call: _e.mock.On("ExtractRepositoryFiles")}
}

func (_c *Storage_ExtractRepositoryFiles_Call) Run(run func()) *Storage_ExtractRepositoryFiles_Call {
	_c.Call.Run(func(args mock.Arguments) {
		run()
	})
	return _c
}

func (_c *Storage_ExtractRepositoryFiles_Call) Return(_a0 []*content.RepositoryFile, _a1 error) *Storage_ExtractRepositoryFiles_Call {
	_c.Call.Return(_a0, _a1)
	return _c
}

// PushBranch provides a mock function with given fields: branch
func (_m *Storage) PushBranch(branch plumbing.ReferenceName) error {
	ret := _m.Called(branch)

	var r0 error
	if rf, ok := ret.Get(0).(func(plumbing.ReferenceName) error); ok {
		r0 = rf(branch)
	} else {
		r0 = ret.Error(0)
	}

	return r0
}

// Storage_PushBranch_Call is a *mock.Call that shadows Run/Return methods with type explicit version for method 'PushBranch'
type Storage_PushBranch_Call struct {
	*mock.Call
}

// PushBranch is a helper method to define mock.On call
//   - branch plumbing.ReferenceName
func (_e *Storage_Expecter) PushBranch(branch interface{}) *Storage_PushBranch_Call {
	return &Storage_PushBranch_Call{Call: _e.mock.On("PushBranch", branch)}
}

func (_c *Storage_PushBranch_Call) Run(run func(branch plumbing.ReferenceName)) *Storage_PushBranch_Call {
	_c.Call.Run(func(args mock.Arguments) {
		run(args[0].(plumbing.ReferenceName))
	})
	return _c
}

func (_c *Storage_PushBranch_Call) Return(_a0 error) *Storage_PushBranch_Call {
	_c.Call.Return(_a0)
	return _c
}

// SaveRepositoryFile provides a mock function with given fields: file
func (_m *Storage) SaveRepositoryFile(file *content.RepositoryFile) (plumbing.Hash, error) {
	ret := _m.Called(file)

	var r0 plumbing.Hash
	if rf, ok := ret.Get(0).(func(*content.RepositoryFile) plumbing.Hash); ok {
		r0 = rf(file)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).(plumbing.Hash)
		}
	}

	var r1 error
	if rf, ok := ret.Get(1).(func(*content.RepositoryFile) error); ok {
		r1 = rf(file)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// Storage_SaveRepositoryFile_Call is a *mock.Call that shadows Run/Return methods with type explicit version for method 'SaveRepositoryFile'
type Storage_SaveRepositoryFile_Call struct {
	*mock.Call
}

// SaveRepositoryFile is a helper method to define mock.On call
//   - file *content.RepositoryFile
func (_e *Storage_Expecter) SaveRepositoryFile(file interface{}) *Storage_SaveRepositoryFile_Call {
	return &Storage_SaveRepositoryFile_Call{Call: _e.mock.On("SaveRepositoryFile", file)}
}

func (_c *Storage_SaveRepositoryFile_Call) Run(run func(file *content.RepositoryFile)) *Storage_SaveRepositoryFile_Call {
	_c.Call.Run(func(args mock.Arguments) {
		run(args[0].(*content.RepositoryFile))
	})
	return _c
}

func (_c *Storage_SaveRepositoryFile_Call) Return(_a0 plumbing.Hash, _a1 error) *Storage_SaveRepositoryFile_Call {
	_c.Call.Return(_a0, _a1)
	return _c
}

// SwitchToBranch provides a mock function with given fields: name
func (_m *Storage) SwitchToBranch(name string) (plumbing.ReferenceName, error) {
	ret := _m.Called(name)

	var r0 plumbing.ReferenceName
	if rf, ok := ret.Get(0).(func(string) plumbing.ReferenceName); ok {
		r0 = rf(name)
	} else {
		r0 = ret.Get(0).(plumbing.ReferenceName)
	}

	var r1 error
	if rf, ok := ret.Get(1).(func(string) error); ok {
		r1 = rf(name)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// Storage_SwitchToBranch_Call is a *mock.Call that shadows Run/Return methods with type explicit version for method 'SwitchToBranch'
type Storage_SwitchToBranch_Call struct {
	*mock.Call
}

// SwitchToBranch is a helper method to define mock.On call
//   - name string
func (_e *Storage_Expecter) SwitchToBranch(name interface{}) *Storage_SwitchToBranch_Call {
	return &Storage_SwitchToBranch_Call{Call: _e.mock.On("SwitchToBranch", name)}
}

func (_c *Storage_SwitchToBranch_Call) Run(run func(name string)) *Storage_SwitchToBranch_Call {
	_c.Call.Run(func(args mock.Arguments) {
		run(args[0].(string))
	})
	return _c
}

func (_c *Storage_SwitchToBranch_Call) Return(_a0 plumbing.ReferenceName, _a1 error) *Storage_SwitchToBranch_Call {
	_c.Call.Return(_a0, _a1)
	return _c
}

type mockConstructorTestingTNewStorage interface {
	mock.TestingT
	Cleanup(func())
}

// NewStorage creates a new instance of Storage. It also registers a testing interface on the mock and a cleanup function to assert the mocks expectations.
func NewStorage(t mockConstructorTestingTNewStorage) *Storage {
	mock := &Storage{}
	mock.Mock.Test(t)

	t.Cleanup(func() { mock.AssertExpectations(t) })

	return mock
}
